<?php

namespace FM\Factory;

use Doctrine\ORM\EntityManager;
use Teknisa\Model\Traits\TQuery;

class Fm00011000AnaliseNaoConformidadesFactory
{
    use TQuery;
    protected $entityManager;
    protected $connection;

    public function __construct(EntityManager $entityManager)
    {
        $this->connection = $entityManager->getConnection();
        $this->entityManager = $entityManager;
    }

    public function getNaoConformidadesGerais($filter)
    {

        $sql = "SELECT CRIT.NRCRITERIOTAREFACHK, CRIT.NMCRITERIOTARGERCHK AS DSCRITERIOTAREFA, LOC.NRLOCALCLIENTE, LOC.NMLOCALCLIENTE, LOC.NRTIPOLOCALCLI, TP.NMTIPOLOCALCLI, OPER.CDOPERADOR, OPER.NMOPERADOR, 
                    HC.CDOPERADORPAI, OPPAI.NMOPERADOR AS NMOPERADORPAI, COUNT(CRIT.NRCRITERIOTAREFACHK) AS QTD
              FROM FCM_GERENCIAMENTOCHK GECHK
              JOIN FCM_TAREFAGERCHK TA
                ON GECHK.NRGERENCIAMENTOCHK = TA.NRGERENCIAMENTOCHK
              JOIN FCM_CRITERIOTARGERCHK CRIT
                ON CRIT.NRTAREFAGERCHK = TA.NRTAREFAGERCHK
              JOIN FCM_CHECKLISTAGEND CKAGND
                ON CKAGND.NRCHECKLISTAGEND = GECHK.NRCHECKLISTAGEND
              JOIN OPERADOR OPER
                ON OPER.CDOPERADOR = CKAGND.CDOPERADOR
              JOIN FCM_FUNCIONARIOSHIERARQ HC
                ON HC.CDOPERADOR = OPER.CDOPERADOR
              JOIN OPERADOR OPPAI
                ON OPPAI.CDOPERADOR = HC.CDOPERADORPAI
              JOIN FCM_HIERARQUIAFUNC HCFUNC
                ON HCFUNC.NRHIERARQUIAFUNC = HC.NRHIERARQUIAFUNC
              JOIN FCM_LOCALCLI LOC
                ON LOC.NRLOCALCLIENTE = GECHK.NRLOCALCLIENTE
              JOIN FCM_TIPOLOCALCLI TP
                ON TP.NRTIPOLOCALCLI = LOC.NRTIPOLOCALCLI
              WHERE HCFUNC.IDATIVO = 'S'
                AND CRIT.IDMARCADO = 'S' " . $filter . "
              GROUP BY OPER.CDOPERADOR, LOC.NRLOCALCLIENTE, HC.CDOPERADORPAI, 
                      OPER.NMOPERADOR, LOC.NMLOCALCLIENTE, OPPAI.NMOPERADOR, 
                      CRIT.NMCRITERIOTARGERCHK, CRIT.NRCRITERIOTAREFACHK, 
                      LOC.NRTIPOLOCALCLI, TP.NMTIPOLOCALCLI";

        return $this->createAndExecuteQueryAndBuildResponseData($this->entityManager, $sql);
    }

    public function getPrincipaisNaoConformidades($filter)
    {

        $sql = "SELECT CTGC.NRCRITERIOTAREFACHK, CTGC.NMCRITERIOTARGERCHK, COUNT(CTGC.NRCRITERIOTAREFACHK) AS QTDADE
              FROM FCM_CRITERIOTARGERCHK CTGC
              JOIN FCM_TAREFAGERCHK TGC
                ON CTGC.NRTAREFAGERCHK = TGC.NRTAREFAGERCHK
                JOIN FCM_GERENCIAMENTOCHK GECHK
                ON GECHK.NRGERENCIAMENTOCHK = TGC.NRGERENCIAMENTOCHK
              WHERE IDMARCADO = 'S' " . $filter . "
          GROUP BY CTGC.NRCRITERIOTAREFACHK, CTGC.NRCRITERIOTAREFACHK, CTGC.NMCRITERIOTARGERCHK
          ORDER BY QTDADE DESC";

        return $this->createAndExecuteQueryAndBuildResponseData($this->entityManager, $sql);
    }

    public function getCriterioNaoConformidade($param)
    {
        $sql = "SELECT LC.NMLOCALCLIENTE || ' | ' || TLC.NMTIPOLOCALCLI AS NMLOCAL, CTAC.NMCRITERIOTARGERCHK
              FROM FCM_CRITERIOTARGERCHK CTAC
              JOIN FCM_TAREFAGERCHK TAC
                ON CTAC.NRTAREFAGERCHK = TAC.NRTAREFAGERCHK
              JOIN FCM_GERENCIAMENTOCHK GC
                ON TAC.NRGERENCIAMENTOCHK = GC.NRGERENCIAMENTOCHK
              JOIN FCM_LOCALCLI LC
                ON GC.NRLOCALCLIENTE = LC.NRLOCALCLIENTE
              JOIN FCM_TIPOLOCALCLI TLC
                ON LC.NRTIPOLOCALCLI = TLC.NRTIPOLOCALCLI
              JOIN FCM_CRITERIOTAREFACHK CTC  
                ON CTAC.NRCRITERIOTAREFACHK = CTC.NRCRITERIOTAREFACHK
              JOIN FCM_CRITERIOTAREFA CT
                ON CTC.NRCRITERIOTAREFA = CT.NRCRITERIOTAREFA
              WHERE CTAC.IDMARCADO = 'S' " . $param;

        return $this->connection->executeQuery($sql)->fetchAllAssociative();
    }
}
